import 'dart:io';

class Router {
  bool add(Route route) {
    switch(route.method) {
      case Route.METHOD_GET:
        _get.add(route);
        return true;
        break;
      case Route.METHOD_POST:
        _post.add(route);
        return true;
        break;
      default:
        return false;
    }
  }
  
  void Handle(HttpRequest req) {
    if(req.method.compareTo(Route.METHOD_GET)==0) {
      _get.firstWhere((Route r) {
        return r.path == req.uri.path;
      }).handle();
    }
    if(req.method.compareTo(Route.METHOD_POST)==0) {
      _post.firstWhere((Route r) {
        return r.path == req.uri.path;
      }).handle();
    }
  }
  
  List<Route> _get = new List<Route>();
  List<Route> _post = new List<Route>();
}

typedef void RouteHandler(HttpRequest request);

abstract class Route {
  static const String METHOD_GET = "GET";
  static const String METHOD_POST = "POST";
  
  String get method;
  String get path;
  RouteHandler handle;
}